local dewdrop = AceLibrary("Dewdrop-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Click2Cast")

local actions = {
	menu = "Menu",
	spell = "Spell",
	target = "Target",
	focus = "Focus",
	assist = "Assist",
	macro = "Macro",
	none = "None",
}
local keybindingOnly = {BUTTON1=true, BUTTON2=true, BUTTON3=true, BUTTON4=true, BUTTON5=true}

local function createSubMenu(self, value)
	local name = dewdrop:EncodeKeybinding(value)
	self.optionsTable.args[value] = {
		name = name,
		desc = name,
		type = 'group',
		args = {
			actions = {
				type = 'text',
				name = L["Set Action"],
				desc = L["actions"],
				order = 1,
				validate = actions,
				get = function() 
					return self.db.profile.clickOptions[value].action
				end,
				set = function(option)
					self.db.profile.clickOptions[value].action = option
					self:EnableFrames()
                    if self.actionText[self.db.profile.clickOptions[value].action] then
                        self.optionsTable.args[value].args.action.name = L[option]
                        self.optionsTable.args[value].args.action.desc = L[option.."Desc"]
                        dewdrop:Refresh(2)
                    end
				end,
			},
			remove = {
				type = 'execute',
				name = L["Remove"],
				desc = L["RemoveDesc"],
				func = function()
					self.db.profile.clickOptions[value] = nil
					self.optionsTable.args[value] = nil
					self:EnableFrames()
					dewdrop:Refresh(1)
					dewdrop:Close(2)
				end,
			},
			action = {
				name = L["Action Text"],
				type = 'text',
				desc = L["actiontext"],
                order = 2,
				get = function()
					return self.db.profile.clickOptions[value].actiontext or ""
				end,
				usage = "",
				set = function(option)
					self.db.profile.clickOptions[value].actiontext = option
					self:EnableFrames()
				end,
				hidden = function()
					return not self.actionText[self.db.profile.clickOptions[value].action]
				end,
			}
		}
	}
    if self.actionText[self.db.profile.clickOptions[value].action] then
        self.optionsTable.args[value].args.action.name = L[self.db.profile.clickOptions[value].action]
        self.optionsTable.args[value].args.action.desc = L[self.db.profile.clickOptions[value].action.."Desc"]
    end
end

function Click2Cast:CreateMenu()
	self.optionsTable = {
		handler = Click2Cast,
		type = 'group',
		args = {},
	}
	
	self.optionsTable.args.new = {
		name = "New binding",
		desc = "New binding",
		order = 200,
		type = 'text',
		validate = "keybinding",
		set = function(value)
			if not self.optionsTable.args[value] then
				createSubMenu(self, value)
			end
		end,
		get = function()
			return nil
		end,
		keybindingOnly = keybindingOnly,
	}
	for k in pairs(self.db.profile.clickOptions) do
		createSubMenu(self, k)
	end
	
	Click2Cast:RegisterChatCommand({ "/Click2Cast", "/c2c", "/cc" }, self.optionsTable)
	Click2Cast.OnMenuRequest = self.optionsTable
end
